var isSquare = function(n){ // fonction booléenne de détection d'un carré:
    // un entier est carré si et seulement sa racine carrée est entière
    return(Math.abs(Math.sqrt(n)-Math.round(Math.sqrt(n)))<1e-10)
}
var N; // le nombre de graines restant dans le jeu
// les lignes suivantes sont une "fonction", qui dit ce qu'il faut faire quand on a cliqué sur une graine
var affichage = function(aubegé,souris) { // la variable souris n'est pas utilisée ici
    var numéro = aubegé.x/32*12-11+aubegé.y/20-1; // on récupère le numéro de la graine cliquée à partir de ses coordonnées
    var enlever = N-numéro+1; // nombre de graines à enlever (si possible)
    var sesame = 1;  // nombre de graines qu'enlèvera l'autre joueur
    if (isSquare(enlever)){ // on n'enlève réellement les graines que si la règle du jeu l'autorise
        alert("Tu enlèves "+enlever+" graine(s),\n et tu peux parce que "+enlever+" est un carré !");
        // affichage du nombre à enlever pour éviter de compter et montrer comment elles sont numérotées
        for(var n=numéro;n<=N;n++){
            graines[n].kill();  // on enlève les graines une par une
        }
        N -= enlever; // du coup le nombre de graines restantes a changé
        if(N==0){   // s'il ne reste plus de graine alors on a gagné
            alert("Tiens, l'herbe est propre, tu as gagné !!!");
        } else {    // du coup s'il reste des graines alors l'autre joueur va jouer 
        alert("Il reste "+N+" graine(s) ");
        if (isSquare(N)){   // si possible en enlevant toutes les graines pour gagner
            sesame = N;
        }
        alert("C'est mon tour de jouer, j'enlève "+sesame+" graine(s).");   // affichage du coup que jouera l'adversaire
        for (var n=N-sesame+1;n<=N;n++){
            graines[n].kill();  // jouer c'est enlever, une par une
        }
        N -= sesame; // mise à jour du nombre de graines restantes
        if (N==0){  // si juste après le jeu de l'adversaire il ne reste plus de graines alors on a perdu
            alert("Et j'ai gagné !!! Nananè-è-re !!!");
        }
        }
    } else {    // si le nombre choisi n'est pas carré on ne peut pas le jouer
        alert("Tu essayes d'enlever "+enlever+" graines \ mais "+enlever+" n'est pas un carré")
    }   // faut le dire ;-)
}
var graines;    // tableau contenant les graines
var game = new Phaser.Game(400,300,Phaser.AUTO,'content',{preload: preload, create: create,update:update});
function preload(){     // à faire avant de créer le jeu
    game.load.image("fond","img/foin.jpg");
    game.load.image("grain","img/grain8.png");
}
function create(){  // création du jeu
    var herbe = game.add.tileSprite(0,0,game.width,game.height,"fond");    //pose du carrelage (décor du jeu)
    herbe.tint = 0x50b050;  // peindre le foin en vert pour qu'il ressemble à une prairie
    herbe.alpha = 0.64; // le rendre légèrement transparent pour le foncer (le fond est noir)
    graines = [0];  //  Pour l'instant il n'y a pas de graines
    N = 120;    // au début du jeu il y a 120 graines (éviter 121 !)
    for(var n=1;n<=120;n++){    // pour chaque numéro de graine
        graines[n] = game.add.sprite(32*Math.floor((n-1)/12)+32,    // (abscisse)
                                    20+20*((n-1)%12),   // (ordonnée)
                                    "grain");   // créer une graine
        graines[n].anchor.setTo(0.5);   // la centrer
        graines[n].scale.setTo(0.5,0.5);    // la rapetisser
        graines[n].inputEnabled=true ;      // la doter d'un système nerveux (pour qu'elle réagisse au clic)
        graines[n].events.onInputDown.add(affichage, this) ;    // la programmer: Quand on la chatouille elle lance la fonction "affichage"
    }
}
function update(){  // animation pour le fun (rotations aléatoires)
    for (var n=1;n<=N;n++)
    graines[n].angle += game.rnd.integerInRange(-20,20);
}

